#include <stdexcept>  
#include <stdio.h>

#include "typedefs.h"
#include "opener_api.h"
#include "cpf.h"
#include "encap.h"

#include "OS32C_EIP_InterfaceDLL.h"  

using namespace std;   

// ----------------------------------------------------------------------------------------------------------------------------------------
// EIP Request Functions
// ----------------------------------------------------------------------------------------------------------------------------------------
extern EIP_INT32 EIP_EncapsulateListIdentityRequestMessage(EIP_BYTE packet[], EIP_UINT16 max_response_delay) 
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateListIdentityRequestMessage(packet, max_response_delay);
	return msg_size;
}

extern EIP_INT32 EIP_EncapsulateTcpRegisterSessionRequestMessage(EIP_BYTE packet[]) 
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateRegisterSessionRequestMessage(packet);
	return msg_size;
}

extern EIP_INT32 EIP_EncapsulateTcpUnRegisterSessionRequestMessage(EIP_BYTE packet[], struct S_Service_Code_Request_Format *request)
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateUnRegisterSessionRequestMessage(packet, request);
	return msg_size;
}

extern EIP_INT32 EIP_EncapsulateTcpStartUdpIOConnectionRequestMessage(EIP_BYTE packet[], struct S_Service_Code_Request_Format *request)
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateSendIOLargeForwardOpenRequestMessage(packet, request);
	return msg_size;
}

extern EIP_INT32 EIP_EncapsulateTcpStopUdpIOConnectionRequestMessage(EIP_BYTE packet[], struct S_Service_Code_Request_Format *request)
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateSendForwardCloseRequestMessage(packet, request);
	return msg_size;
}

extern EIP_INT32 EIP_EncapsulateUdpIOConnectionKeepAliveRequestMessage(EIP_BYTE packet[], struct S_Service_Code_Request_Format *request)
{
  EIP_INT32 msg_size = 0;
  msg_size = encapsulateSendIOKeepAliveMessage(packet, request);
  return msg_size;
}

extern EIP_INT32 EIP_EncapsulateTcpSendRRDataExplicitRequestMessage(EIP_BYTE packet[], struct S_Service_Code_Request_Format *request)
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateUCMMSendRRDataRequestMessage(packet, request);
    return msg_size;
}

extern EIP_INT32 EIP_EncapsulateTcpConnectionKeepAliveRequestMessage(EIP_BYTE packet[], struct S_Service_Code_Request_Format *request) 
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateNopRequestMessage(packet, request);
	return msg_size;
}

extern EIP_INT32 EIP_EncapsulateTcpSendUnitDataExplicitRequestMessage(EIP_BYTE packet[], struct S_Service_Code_Request_Format *request)
{
	EIP_INT32 msg_size = 0;
	msg_size = encapsulateSendUnitDataRequestMessage(packet, request);
    return msg_size;
}



// ----------------------------------------------------------------------------------------------------------------------------------------



// ----------------------------------------------------------------------------------------------------------------------------------------
// EIP Response Functions
// ----------------------------------------------------------------------------------------------------------------------------------------
extern EIP_INT32 EIP_GetListIdentyResponseMessage(EIP_BYTE packet[], struct S_Encapsulation_ListIdentityResponse *response)
{
  EIP_INT32 msg_size = 0;

  // extract the returned data from rx packet
  (void *)memcpy(&response, &packet[0], LIST_RESPONSE_LENGTH_WITOUT_NAME);

  // extract product name using the name length information.
  (void *)memcpy(&response->product_name[0], (EIP_INT8 *) &packet[LIST_RESPONSE_LENGTH_WITOUT_NAME], response->name_length);

  // extract product state using the name length information.
  (void *)memcpy(&response->product_state, (EIP_INT8 *) &packet[LIST_RESPONSE_LENGTH_WITOUT_NAME + response->name_length], sizeof(EIP_BYTE));

  return (LIST_RESPONSE_LENGTH_WITOUT_NAME + response->name_length + sizeof(EIP_BYTE));
}

extern EIP_INT32 EIP_GetRegisterSessionResponseMessage(EIP_BYTE packet[], struct S_Encapsulation_RegisterSessionResponse *response)
{
  EIP_INT32 msg_size = sizeof(response);

  // extract the returned data from rx packet
  (void *)memcpy(&response, &packet[0], msg_size);

  return (msg_size);
}
// ----------------------------------------------------------------------------------------------------------------------------------------
